package com.nebu.nebula.service;

import com.vesoft.nebula.client.graph.NebulaPoolConfig;
import com.vesoft.nebula.client.graph.data.HostAddress;
import com.vesoft.nebula.client.graph.data.ResultSet;
import com.vesoft.nebula.client.graph.data.ValueWrapper;
import com.vesoft.nebula.client.graph.exception.IOErrorException;
import com.vesoft.nebula.client.graph.net.NebulaPool;
import com.vesoft.nebula.client.graph.net.Session;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.UnsupportedEncodingException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.concurrent.TimeUnit;

public class GraphClientExample2 {
    private static final Logger log = LoggerFactory.getLogger(GraphClientExample2.class);
        public static void insert(String s,int i) {
        NebulaPool pool = new NebulaPool();
        Session session = null;
        try {
            NebulaPoolConfig nebulaPoolConfig = new NebulaPoolConfig();
            nebulaPoolConfig.setMaxConnSize(100);
            List<HostAddress> addresses = Arrays.asList(new HostAddress("192.168.216.129", 9669));
            session = pool.getSession("root", "nebula", false);
            {
                String createSchema = "CREATE SPACE  IF NOT EXISTS test3; "
                        + "USE test3;"
                        + "CREATE TAG IF NOT EXISTS factory(name string, address string,phoneNum string);"
                        + "CREATE TAG IF NOT EXISTS dealers(name string, address string, phoneNum string, level string, arrivalTime date, outTime date);"
                        + "CREATE TAG IF NOT EXISTS seller(name string, address string,phoneNum string, arrivalTime date, outTime date);"
                        + "CREATE TAG IF NOT EXISTS boxes(name string, years int, productionData string);"
                        + "CREATE TAG IF NOT EXISTS box(name string, years int, productionData string);"
                        + "CREATE TAG IF NOT EXISTS bottle(name string, productionData string);"
                        + "CREATE EDGE IF NOT EXISTS like(likeness double)";
                ResultSet resp = session.execute(createSchema);
                if (!resp.isSucceeded()) {
                    log.error(String.format("Execute: `%s', failed: %s",
                            createSchema, resp.getErrorMessage()));
                    System.exit(1);
                }
            }
            if (i == 1){
                insertVertexes(session,s);
            }
            if (i == 2){
                insertEdges(session,s);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session != null) {
                session.release();
            }
            pool.close();
        }
    }
    public static void insertVertexes(Session session,String s){
        ResultSet resp = null;
        try {
            resp = session.execute(s);
        } catch (IOErrorException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        if (!resp.isSucceeded()) {
            log.error(String.format("Execute: `%s', failed: %s",
                    s, resp.getErrorMessage()));
            System.exit(1);
        }
    }

    public static void insertEdges(Session session,String s){
        ResultSet resp = null;

        try {
            resp = session.execute(s);
        } catch (IOErrorException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        if (!resp.isSucceeded()) {
            log.error(String.format("Execute: `%s', failed: %s",
                    s, resp.getErrorMessage()));
            System.exit(1);
        }
    }
}