package com.nebu.nebula;

import com.nebu.nebula.bean.*;
import com.nebu.nebula.service.GraphClientExample2;
import com.nebu.nebula.utils.VidRandom;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;



/**
 * bash /usr/local/nebula-graph-studio/scripts/start.sh
 * sudo /usr/local/nebula/scripts/nebula.service status all
 */
@SpringBootTest
@Slf4j
class NebulaGraphTestApplicationTests {

    @Test
    void contextLoads9() {
        long start = System.currentTimeMillis();
        ArrayList<Dealers> dealers = new ArrayList<>();
        //现在默认的只有5个一级经销商，所有手动创建
        dealers.add(new Dealers("2", "成都经销商", "成都市武侯区", "66666666", "一级经销商"));
        dealers.add(new Dealers("3", "上海经销商", "上海市虹桥机场", "66666666", "一级经销商"));
        dealers.add(new Dealers("4", "北京经销商", "北京市故宫", "66666666", "一级经销商"));
        dealers.add(new Dealers("5", "天津经销商", "成都市武侯区", "66666666", "一级经销商"));
        dealers.add(new Dealers("6", "成都经销商", "成都市武侯区", "66666666", "一级经销商"));
        dealers.add(new Dealers("7", "成都经销商", "成都市武侯区", "66666666", "一级经销商"));
        AtomicInteger m = new AtomicInteger(8);
        Random random = new Random();
        dealers.stream().parallel().forEach((de) -> {
            ArrayList<Seller> list = new ArrayList<>();
            GraphClientExample2.insert(de.genInsertVertexes3(), 1);
            for (int j = 0; j < 100; j++) { //这里是随机为每个一级经销商生成1到100个卖家
                Seller seller = new Seller(m + "", m + "", VidRandom.getAdd(random.nextInt(30)), m + "", null);
                GraphClientExample2.insert(seller.genInsertVertexes3(), 1);//插入点
                String string = VidRandom.getString(m + "", de.getVid());
                GraphClientExample2.insert(string, 2);//两个顶点建立关系
                m.getAndIncrement();
                list.add(seller);
            }
            list.stream().parallel().forEach((seller) -> {
                ArrayList<Boxes> boxes = new ArrayList<>();
                int year = random.nextInt(4) + 1;
                String date = VidRandom.getIntDate();
                for (int j = 0; j < random.nextInt(20000) + 1; j++) {//这里是随机为每个商家生成1到100的多少箱酒
                    Boxes boxes1 = new Boxes(m + "", "五浪液", year, date, null);
                    GraphClientExample2.insert(boxes1.genInsertVertexes2(), 1);
                    String string = VidRandom.getString(m + "", seller.getVid());
                    GraphClientExample2.insert(string, 2);
                    m.getAndIncrement();
                    boxes.add(boxes1);
                }
                seller.setBoxesList(boxes);
                boxes.stream().parallel().forEach((box) -> {
                    ArrayList<Box> he = new ArrayList<>();
                    int i1 = random.nextInt(4) + 1;
                    for (int j = 0; j < random.nextInt(6) + 2; j++) {//每个箱子里面随机生成2到6盒酒
                        Box box1 = new Box(m + "", "五粮液", year, date, null);
                        GraphClientExample2.insert(box1.genInsertVertexes2(), 1);
                        String string = VidRandom.getString(m + "", box.getVid());
                        GraphClientExample2.insert(string, 2);
                        m.getAndIncrement();
                        he.add(box1);
                    }
                    he.stream().parallel().forEach((box1)->{
                        //对应着瓶
                        for (int j = 0; j < i1; j++) {
                            Bottle bottle = new Bottle(m + "", "五粮液", date, (List<Code>) null);
                            GraphClientExample2.insert(bottle.genInsertVertexes2(), 1);
                            String string = VidRandom.getString(m + "", box1.getVid());
                            GraphClientExample2.insert(string, 2);
                            m.getAndIncrement();
                        }
                    });
                });
            });
        });
        Factory factory = new Factory(dealers);
        List<Dealers> dealersList = factory.getDealersList();
        GraphClientExample2.insert(factory.genInsertVertexes2(), 1);
        for (Dealers dealers1 : dealersList) {
            String string = VidRandom.getString(dealers1.getVid(), factory.getVid());
            GraphClientExample2.insert(string, 2);
        }
        long end = System.currentTimeMillis();
        log.error("插入的数据总量是{}",m);
        log.error("插入时间是{}", end - start);
    }

    @Test
    public void tets20() {
        String date = VidRandom.getIntDate();
        Bottle bottle = new Bottle(500000 + "", "五粮液", date, (List<Code>) null);
        GraphClientExample2.insert(bottle.genInsertVertexes2() , 1);
    }
}
